import java.awt.*;
import java.awt.image.*;
import java.awt.geom.*;
import java.awt.font.*;
import java.util.*;
import javax.imageio.*;
import javax.imageio.stream.*;
import java.io.*;


class Animator{

	static BufferedImage dummyimg = new BufferedImage(1,1,BufferedImage.TYPE_4BYTE_ABGR);
	static Graphics2D graph= dummyimg.createGraphics();
	static HashMap imgs=new HashMap();
	static HashMap explodeimgs=new HashMap();
	static HashMap rotateimgs=new HashMap();
	static BufferedImage getImg(String s) {
//		if(imgs==null)	loadImages();
		BufferedImage img=(BufferedImage)imgs.get(s);		
		if (img==null){			
			String filename=s;
			if (s.indexOf('.')<0) filename+=".png";
			try{	
				ImageInputStream st=new MemoryCacheImageInputStream((Animator.class).getClassLoader().getResource("grafik/"+filename).openStream());
				//(Animator.class).getClassLoader().getResource("grafik/"+filename).openStream()
				//System.out.println("-1");
				ImageIO.setUseCache(false);
				//Iterator it= ImageIO.getImageReadersBySuffix("png");
//				System.out.println("0");
//				ImageReader r=(ImageReader)it.next();
				img=ImageIO.read(st);
//				System.out.println("1");	
//				r.setInput(st);
//				System.out.println("2");
//				img=r.read(0);
//				System.out.println("3");
			}
			catch (Exception e) {System.out.print(e);}
			System.out.println("Img loaded: "+filename);
			imgs.put(s,img);
		}
		return img;
	}
	static Image[] getExploder(String s) {	return getExploder(s,35);}
	
	static Image[] getExploder(String s, int frames){
		Image[] i=(Image[])explodeimgs.get(s);
		if (i==null) 
		{
			explodeimgs.put(s, i=makeExploder(getImg(s), frames));
		}
		return i;
	}

	static Image[] getRotator(String s) {
		Image[] i=(Image[])rotateimgs.get(s);
		if (i==null) 
		{
			rotateimgs.put(s, i=makeRotator(getImg(s)));
		}
		return i;
	}
	
	static HashMap loadImages()	{
		imgs=new HashMap();	
		File[] list=(new File("grafik")).listFiles();
		for (int i=0; i<list.length; i++){
			try{				
				String n=list[i].getName();				
				Image img=ImageIO.read(list[i]);
				if (img!=null) imgs.put(n.substring(0, n.length()-4) , img);
			} catch (Exception e) {System.out.print(e);}
		}
		System.out.println(imgs.keySet().toString());						
		return imgs;
	}	
	static Image[] makeRotator(Image img){
		int anz=64;
		Image[] imgs=new Image[anz];
		int w= img.getWidth(null);
		int h= img.getHeight(null);
		int s=Math.max(w,h);		
		for (int i=0; i<anz; i++){		
			BufferedImage im = new BufferedImage(s,s,BufferedImage.TYPE_4BYTE_ABGR);
			Graphics2D g=im.createGraphics();
			g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
			AffineTransform rot=new AffineTransform();
			rot.rotate((i*Math.PI/anz*2),w/2,h/2);
			g.setTransform(rot);
			g.drawImage(img,0,0,null);
			imgs[i]=im;
		}
		return imgs;
	}		
	static Image[] makeExploder(Image img, int anz){
		Image[] imgs=new Image[anz];
		int w= img.getWidth(null);
		int h= img.getHeight(null);
		int s=Math.max(w,h);		
		for (int i=0; i<anz; i++)
		{		
			BufferedImage im = new BufferedImage(s,s,BufferedImage.TYPE_4BYTE_ABGR);
			Graphics2D g=im.createGraphics();
			g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
			AffineTransform rot=new AffineTransform();
			double alpha=((double)i)/anz;
			double scale=(alpha+1)/2;
			rot.translate(w/2*(1-scale),h/2*(1-scale));
			rot.scale(scale,scale);
			g.setTransform(rot);			
			g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1-(float)(alpha)));
			g.drawImage(img,0,0,null);
			imgs[i]=im;
		}
		return imgs;
	}
	
	static void particleLine(BobList gl, Image[] imgs, double x1,double y1, double x2, double y2,double count)	{
		double dist=Math.abs(x1-x2)+Math.abs(y1-y2);
		count*=dist;
		for (int i=1; i<count; i++){
			double d=((double)i)/count;
			double x= x1*(1-d)+x2*d;
			double y= y1*(1-d)+y2*d;
			InertBob b =new InertBob(imgs, x,y,Math.random()*Math.PI*2);
			b.pointAt(x1,y1);
			b.setVelocity(0,0,((int)(Math.random()*6) )/20.0);
			b.setDamper(.96);
			gl.add(b);
		}				
	}
	static InertBob[] particleGlyph (String s, Image[] imgs, double size)	{
		BobList l = new BobList();
		Shape shape=getGlyphShape(s);
		AffineTransform at=new AffineTransform();
		at.scale(size,size);
		PathIterator pit= new FlatteningPathIterator(shape.getPathIterator(at),size*10);
		double[] p =new double[6],q =new double[6], temp;
//		double count=20.0/imgs[0].getWidth(null);
		double count=4/size;
		while (! pit.isDone())
		{	
			temp=q;
			q=p;
			p=temp;			
			int cs = pit.currentSegment(p);
			if (cs==PathIterator.SEG_LINETO) particleLine(l,imgs, q[0],q[1],p[0],p[1],count);
			pit.next();
		}
		return (InertBob[])l.toArray(new InertBob[1]);
	}
	
	static ParticleCloud getParticleText(String s, double size){
		return getParticleText(s,new Image[1], size);
	}
	static ParticleCloud getParticleText(String s, Image[] imgs, double size){
		ParticleCloud p=new ParticleCloud(particleGlyph(s,imgs,size));
		p.explode(0,0,1);
		return	p;
	}
	
	static Shape getGlyphShape(String s){
		Font f=graph.getFont();
		GlyphVector gl=f.createGlyphVector(graph.getFontRenderContext(),s);
		gl.performDefaultLayout();
		
		Rectangle2D r=gl.getVisualBounds();
		
		float x=(float)-r.getCenterX(), y=(float)-r.getCenterY();		
		return gl.getOutline(x,y);
	}
}
