import java.awt.*;

class Player extends InertBob
{
	Image baseimg=Animator.getImg("playerBase");
	static Image[]  engineimgs=Animator.getRotator("playerEngines"),
				thrustimgs=Animator.getRotator("playerThrust"),
				imgs=Animator.getRotator("playerGun"),
				haloimgs=Animator.getExploder("playerHalo",5),
	 			shotimgs	= Animator.getRotator("shot");
	static Color blue=new Color(100,100,255,100);
	
	double enginea,turreta;
	boolean shoot, move;
	float speed=0;
	int reload=0;
	int kills=0;
	int energy=100;
	Explosion halo=null;
	
	Player(){		
		setXY(100,100);
	}
	void move(double dx, double dy){
		super.move(dx,dy);
		enginea = 2*Math.PI;
		enginea+= Math.atan(dy/dx);
		if (dx<0)
			enginea+=Math.PI;		
		speed=(float)Math.min((Math.abs(dx)+Math.abs(dy))/10,1);			
	}
	public void update(BobList shots, BobList enemies, BobList enemyshots, int mx, int my){
		if(!visible) return;
		if (move)	{setVelocity((mx-x)/10,(my-y)/10,0); move(vx,vy);}		
		else setVelocity(0,0,0);		
		pointAt(mx,my);
		reload--;
		if (shoot && reload<0)	{
			Shot shot=new StraightShot(shotimgs,this,20,0);
			shots.add(shot);
			shot.radius=2;
			Sounder.play("shot");
			reload=2;
		}
		if (halo!=null) 			halo.update();
	}
	public void hit(BobList e){
		Sounder.play("treffer");
			halo =  new Explosion(haloimgs,this);
			energy--;
			if (energy<=0)  {
				setVisible(false);
				for (int i=0;i<10;i++){
					e.add(new Bone(engineimgs ,this));
					e.add(new Bone(imgs,this));
					e.add(new Bone(thrustimgs,this));				
				}
			}
	}
	void draw(Graphics g){
		if (!visible) return;
		if (halo!=null)	halo.draw(g);					
		img=baseimg;
		turreta=a;			
		super.draw(g);
		setImage(engineimgs, enginea);
		super.draw(g);
		if(move){
			((Graphics2D)g).setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER,speed));	
			setImage(thrustimgs, enginea);
			super.draw(g);
			((Graphics2D)g).setComposite(AlphaComposite.SrcOver);	
		}
		setImage(imgs, turreta);
		super.draw(g);
		g.setColor(blue);
		double dx=1000*Math.cos(a);
		double dy=1000*Math.sin(a);
		g.drawLine((int)x,(int)y,(int)(x+dx), (int)(y+dy));
	}
	void disable(){	reload=Integer.MAX_VALUE;	}
	void enable(){	reload=0;}
}