/*
 * Sounder.java
 * Paul Geisler 2005 (www.hirnsohle.de)
 * 
 * 
 * Mal sehen was Sun sich als nchstes einfallen lsst...
 * 
 * Spielt einen WAV-File ab, der sich im lokalen pfad sound/<name>.wav befindet
 * keine Initalisation erforderlich
 * 
 * Ein einziger statischer Aufruf:
 * Sounder.play("<name(ohne .WAV)>"); 
 *
 *Der Sound wird zur Laufzeit geladen und dann frs weitere gecachet
 *  
 * Es knnen ROUNDS Samples des gleichen Files simultan gespielt werden
 * 
 *KOMPATIBEL: JRE 1.4.0 - 1.5.0 
 *BUG bei 1.5.0: WAVes drfen _nicht_ in einem komprimierten Archiv gehalten werden 
 * 
 * Hoffe mal es funzt, viel Glck, du wirst es brauchen.
 *
 * Diese Engine bewhrt sich zur Zeit in XAP! : 
 * http://hirnsohle.de/xapentry.htm
 * 
 **/

import java.util.*;
import java.io.*;
import javax.sound.sampled.*;

class Sample implements Runnable{
	AudioFormat format;
	AudioInputStream ais;
	int size;
	int round;
	final int ROUNDS=3;
	Clip[] clip=new Clip[ROUNDS];	
	Sample(String filename) {
		try{			
			ais = AudioSystem.getAudioInputStream((Sounder.class).getClassLoader().getResource("sound/"+filename));
			format = ais.getFormat();
			size = (int) (format.getFrameSize() * ais.getFrameLength());
			byte[] audio = new byte[size];
	 		ais.read(audio, 0, size);
	 		Mixer.Info[] mixers=AudioSystem.getMixerInfo();
	 		Mixer mixer=null;
			for (int i=0; i<mixers.length; i++){
				if (mixers[i].getName().equals("Java Sound Audio Engine"))
					mixer=AudioSystem.getMixer(mixers[i]);
			}
			DataLine.Info info= new DataLine.Info(Clip.class, format,AudioSystem.NOT_SPECIFIED);
			for (int i=0; i<ROUNDS; i++){
				clip[i]=(Clip)mixer.getLine(info);									
				clip[i].open(format, audio, 0, size);
			}
		}catch (Exception e) {System.out.println(e);}
	}	
	void play(){		
		run();
	}

	public void run(){
		try{			
			Clip clip=this.clip[(round++)%ROUNDS];			
			clip.setFramePosition(0);
			clip.start();			
		}catch (Exception e) {System.out.println(e);}
	}
}

class Sounder{
	static HashMap samples=new HashMap();
	static boolean sound=true;
	//static boolean sound=false;
	static void  load()	{
		if(!sound) return;
		File[] list=(new File("sound")).listFiles();
		for (int i=0; i<list.length; i++)
		{
			try{
				String n=list[i].getName();
			} catch (Exception e) {System.out.print(e);}
		}
		System.out.println(samples.keySet().toString());
	}

	static void play(String name)	{
		if (!sound) return;
		Sample samp=(Sample)samples.get(name);
		if (samp==null){
			String filename=name;
			if (name.indexOf('.')<0) filename+=".wav";
			samp=new Sample(filename);
			System.out.println("Snd loaded: "+filename);
			samples.put(name,samp);
		}		
		samp.play();
	}
}